/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:clarke2:Two input version of Clarke transform");
MODULE_INFO(linuxcnc, "descr:The Clarke transform can be used to translate a vector\nquantity from a three phase system (three components 120 degrees\napart) to a two phase Cartesian system.\n.P\n\\fBclarke2\\fR implements\na special case of the Clarke transform, which only needs two of the\nthree input phases.  In a three wire three phase system, the sum of the\nthree phase currents or voltages must always be zero.  As a result only\ntwo of the three are needed to completely define the current or voltage.\n\\fBclarke2\\fR assumes that the sum is zero, so it only uses phases A and\nB of the input.  Since the H (homopolar) output will always be zero in\nthis case, it is not generated.");
MODULE_INFO(linuxcnc, "see_also:\\fBclarke3\\fR(9) for the general case, \\fBclarkeinv\\fR(9) for\nthe inverse transform.");
MODULE_INFO(linuxcnc, "pin:a:float:0:in::None:None");
MODULE_INFO(linuxcnc, "pin:b:float:0:in:first two phases of three phase input:None:None");
MODULE_INFO(linuxcnc, "pin:x:float:0:out::None:None");
MODULE_INFO(linuxcnc, "pin:y:float:0:out:cartesian components of output:None:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:John Kasunich");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *a;
    hal_float_t *b;
    hal_float_t *x;
    hal_float_t *y;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_float_newf(HAL_IN, &(inst->a), comp_id,
        "%s.a", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->b), comp_id,
        "%s.b", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->x), comp_id,
        "%s.x", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->y), comp_id,
        "%s.y", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of clarke2");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of clarke2");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("clarke2");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "clarke2.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef a
#define a (0+*__comp_inst->a)
#undef b
#define b (0+*__comp_inst->b)
#undef x
#define x (*__comp_inst->x)
#undef y
#define y (*__comp_inst->y)


#line 22 "hal/components/clarke2.comp"

/* for the details, google "clarke transform", or see section 3 of
   http://focus.ti.com/lit/an/bpra048/bpra048.pdf and/or appendix B of
   http://www.esat.kuleuven.be/electa/publications/fulltexts/pub_1610.pdf
*/

#define K1 (0.577350269189626)  /* 1/sqrt(3) */
#define K2 (1.154700538379250)  /* 2/sqrt(3) */

FUNCTION(_) {
    x = a;
    y = K1*a + K2*b;
}

static int __comp_get_data_size(void) { return 0; }
