/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:conv_float_s32:Convert a value from float to s32");
MODULE_INFO(linuxcnc, "pin:in_:float:0:in::None:None");
MODULE_INFO(linuxcnc, "pin:out:s32:0:out::None:None");
MODULE_INFO(linuxcnc, "pin:out_of_range:bit:0:out:TRUE when 'in' is not in the range of s32:None:None");
MODULE_INFO(linuxcnc, "param:clamp:bit:0:rw:If TRUE, then clamp to the range of s32.  If FALSE, then allow the value to \"wrap around\".:None:None");
MODULE_INFO(linuxcnc, "funct:_:1:Update 'out' based on 'in'");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Jeff Epler");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *in_;
    hal_s32_t *out;
    hal_bit_t *out_of_range;
    hal_bit_t clamp;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_float_newf(HAL_IN, &(inst->in_), comp_id,
        "%s.in", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->out_of_range), comp_id,
        "%s.out-of-range", prefix);
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RW, &(inst->clamp), comp_id,
        "%s.clamp", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of conv_float_s32");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of conv_float_s32");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("conv_float_s32");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "conv-float-s32.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in_
#define in_ (0+*__comp_inst->in_)
#undef out
#define out (*__comp_inst->out)
#undef out_of_range
#define out_of_range (*__comp_inst->out_of_range)
#undef clamp
#define clamp (__comp_inst->clamp)


#line 11 "hal/components/conv_float_s32.comp"
FUNCTION(_) {
    hal_float_t in = in_;
    if(clamp) {
#if 2147483647 != 0
	if(in > 2147483647) { out = 2147483647; out_of_range = 1; return; }
#endif
#if -2147483647-1 != -1
	if(in < -2147483647-1) { out = -2147483647-1; out_of_range = 1; return; }
#endif
	out = in; out_of_range = 0;
    } else {
	out = in;
	if(out != in) out_of_range = 1;
    }
}

static int __comp_get_data_size(void) { return 0; }
