/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:differential:kinematics for a differential transmission");
MODULE_INFO(linuxcnc, "pin:roll-cmd:float:0:in:position command for roll (in degrees):None:None");
MODULE_INFO(linuxcnc, "pin:pitch-cmd:float:0:in:position command for pitch (in degrees):None:None");
MODULE_INFO(linuxcnc, "pin:roll-fb:float:0:out:position feedback for roll (in degrees):None:None");
MODULE_INFO(linuxcnc, "pin:pitch-fb:float:0:out:position feedback for pitch (in degrees):None:None");
MODULE_INFO(linuxcnc, "pin:motor0-cmd:float:0:out:position command to motor0 (based on roll & pitch inputs):None:None");
MODULE_INFO(linuxcnc, "pin:motor1-cmd:float:0:out:position command to motor1 (based on roll & pitch inputs):None:None");
MODULE_INFO(linuxcnc, "pin:motor0-fb:float:0:in:position feedback from motor0:None:None");
MODULE_INFO(linuxcnc, "pin:motor1-fb:float:0:in:position feedback from motor1:None:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Sebastian Kuzminsky");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *roll_cmd;
    hal_float_t *pitch_cmd;
    hal_float_t *roll_fb;
    hal_float_t *pitch_fb;
    hal_float_t *motor0_cmd;
    hal_float_t *motor1_cmd;
    hal_float_t *motor0_fb;
    hal_float_t *motor1_fb;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_float_newf(HAL_IN, &(inst->roll_cmd), comp_id,
        "%s.roll-cmd", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->pitch_cmd), comp_id,
        "%s.pitch-cmd", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->roll_fb), comp_id,
        "%s.roll-fb", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->pitch_fb), comp_id,
        "%s.pitch-fb", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->motor0_cmd), comp_id,
        "%s.motor0-cmd", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->motor1_cmd), comp_id,
        "%s.motor1-cmd", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->motor0_fb), comp_id,
        "%s.motor0-fb", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->motor1_fb), comp_id,
        "%s.motor1-fb", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of differential");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of differential");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("differential");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "differential.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef roll_cmd
#define roll_cmd (0+*__comp_inst->roll_cmd)
#undef pitch_cmd
#define pitch_cmd (0+*__comp_inst->pitch_cmd)
#undef roll_fb
#define roll_fb (*__comp_inst->roll_fb)
#undef pitch_fb
#define pitch_fb (*__comp_inst->pitch_fb)
#undef motor0_cmd
#define motor0_cmd (*__comp_inst->motor0_cmd)
#undef motor1_cmd
#define motor1_cmd (*__comp_inst->motor1_cmd)
#undef motor0_fb
#define motor0_fb (0+*__comp_inst->motor0_fb)
#undef motor1_fb
#define motor1_fb (0+*__comp_inst->motor1_fb)


#line 37 "hal/components/differential.comp"

FUNCTION(_) {
    motor0_cmd = roll_cmd + pitch_cmd;
    motor1_cmd = roll_cmd - pitch_cmd;

    roll_fb = (motor0_fb + motor1_fb)/2;
    pitch_fb = (motor0_fb - motor1_fb)/2;
}

static int __comp_get_data_size(void) { return 0; }
