/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:gearchange:Select from one two speed ranges\nThe output will be a value scaled for the selected gear, and clamped to\nthe min/max values for that gear.\nThe scale of gear 1 is assumed to be 1, so the output device scale\nshould be chosen accordingly.\nThe scale of gear 2 is relative to gear 1, so if gear 2 runs the spindle\n2.5 times as fast as gear 1, scale2 should be set to 2.5.");
MODULE_INFO(linuxcnc, "pin:sel:bit:0:in:Gear selection input:None:None");
MODULE_INFO(linuxcnc, "pin:speed_in:float:0:in:Speed command input:None:None");
MODULE_INFO(linuxcnc, "pin:speed_out:float:0:out:Speed command to DAC/PWM:None:None");
MODULE_INFO(linuxcnc, "pin:dir_in:bit:0:in:Direction command input:None:None");
MODULE_INFO(linuxcnc, "pin:dir_out:bit:0:out:Direction output - possibly inverted for second gear:None:None");
MODULE_INFO(linuxcnc, "param:min1:float:0:rw:Minimum allowed speed in gear range 1:0:None");
MODULE_INFO(linuxcnc, "param:max1:float:0:rw:Maximum allowed speed in gear range 1:100000:None");
MODULE_INFO(linuxcnc, "param:min2:float:0:rw:Minimum allowed speed in gear range 2:0:None");
MODULE_INFO(linuxcnc, "param:max2:float:0:rw:Maximum allowed speed in gear range 2:100000:None");
MODULE_INFO(linuxcnc, "param:scale2:float:0:rw:Relative scale of gear 2 vs. gear 1.\nSince it is assumed that gear 2 is \"high gear\", \\fBscale2\\fR must be\ngreater than 1, and will be reset to 1 if set lower.:1.0:None");
MODULE_INFO(linuxcnc, "param:reverse:bit:0:rw:Set to 1 to reverse the spindle in second gear.:0:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Stephen Wille Padnos");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *sel;
    hal_float_t *speed_in;
    hal_float_t *speed_out;
    hal_bit_t *dir_in;
    hal_bit_t *dir_out;
    hal_float_t min1;
    hal_float_t max1;
    hal_float_t min2;
    hal_float_t max2;
    hal_float_t scale2;
    hal_bit_t reverse;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_bit_newf(HAL_IN, &(inst->sel), comp_id,
        "%s.sel", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->speed_in), comp_id,
        "%s.speed-in", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->speed_out), comp_id,
        "%s.speed-out", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->dir_in), comp_id,
        "%s.dir-in", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->dir_out), comp_id,
        "%s.dir-out", prefix);
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->min1), comp_id,
        "%s.min1", prefix);
    inst->min1 = 0;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->max1), comp_id,
        "%s.max1", prefix);
    inst->max1 = 100000;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->min2), comp_id,
        "%s.min2", prefix);
    inst->min2 = 0;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->max2), comp_id,
        "%s.max2", prefix);
    inst->max2 = 100000;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->scale2), comp_id,
        "%s.scale2", prefix);
    inst->scale2 = 1.0;
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RW, &(inst->reverse), comp_id,
        "%s.reverse", prefix);
    inst->reverse = 0;
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of gearchange");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of gearchange");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("gearchange");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "gearchange.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef sel
#define sel (0+*__comp_inst->sel)
#undef speed_in
#define speed_in (0+*__comp_inst->speed_in)
#undef speed_out
#define speed_out (*__comp_inst->speed_out)
#undef dir_in
#define dir_in (0+*__comp_inst->dir_in)
#undef dir_out
#define dir_out (*__comp_inst->dir_out)
#undef min1
#define min1 (__comp_inst->min1)
#undef max1
#define max1 (__comp_inst->max1)
#undef min2
#define min2 (__comp_inst->min2)
#undef max2
#define max2 (__comp_inst->max2)
#undef scale2
#define scale2 (__comp_inst->scale2)
#undef reverse
#define reverse (__comp_inst->reverse)


#line 26 "hal/components/gearchange.comp"
FUNCTION(_) {
    hal_float_t temp_in = speed_in;
    hal_float_t sign=1;
    /* Assume that the output device is scaled so that gear 1 is "Pass-through" */
    /* the other gear(s) need to be scaled by the relative scale for that gear */
    if (scale2 < 1) scale2 = 1;
    if (temp_in < 0) {
	sign = -1;
	temp_in = -temp_in;
    }
    if(sel) {		/* gear 2 */
    	if (temp_in < min2) temp_in = min2;
    	else if (temp_in > max2) temp_in = max2;
    	temp_in /= scale2;		/* scale up to second gear output range */
	dir_out = dir_in ^ reverse;
    } else {
    	if (temp_in < min1) temp_in = min1;
    	else if (temp_in > max1) temp_in = max1;
	dir_out = dir_in;
    }
    speed_out = sign*temp_in;
}

static int __comp_get_data_size(void) { return 0; }
