/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:knob2float:Convert counts (probably from an encoder) to a float value");
MODULE_INFO(linuxcnc, "pin:counts:s32:0:in:Counts:None:None");
MODULE_INFO(linuxcnc, "pin:enable:bit:0:in:When TRUE, output is controlled by count, when FALSE, output is fixed:None:None");
MODULE_INFO(linuxcnc, "pin:scale:float:0:in:Amount of output change per count:None:None");
MODULE_INFO(linuxcnc, "pin:out:float:0:out:Output value:None:None");
MODULE_INFO(linuxcnc, "param:max_out:float:0:rw:Maximum output value, further increases in count will be ignored:1.0:None");
MODULE_INFO(linuxcnc, "param:min_out:float:0:rw:Minimum output value, further decreases in count will be ignored:0.0:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:John Kasunich");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_s32_t *counts;
    hal_bit_t *enable;
    hal_float_t *scale;
    hal_float_t *out;
    hal_float_t max_out;
    hal_float_t min_out;
    void *_data;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_data = (char*)inst + sizeof(struct __comp_state);
    r = hal_pin_s32_newf(HAL_IN, &(inst->counts), comp_id,
        "%s.counts", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->enable), comp_id,
        "%s.enable", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->scale), comp_id,
        "%s.scale", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->max_out), comp_id,
        "%s.max-out", prefix);
    inst->max_out = 1.0;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->min_out), comp_id,
        "%s.min-out", prefix);
    inst->min_out = 0.0;
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of knob2float");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of knob2float");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("knob2float");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "knob2float.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef counts
#define counts (0+*__comp_inst->counts)
#undef enable
#define enable (0+*__comp_inst->enable)
#undef scale
#define scale (0+*__comp_inst->scale)
#undef out
#define out (*__comp_inst->out)
#undef max_out
#define max_out (__comp_inst->max_out)
#undef min_out
#define min_out (__comp_inst->min_out)
#undef data
#define data (*(knob2float_data*)(__comp_inst->_data))


#line 34 "hal/components/knob2float.comp"

typedef struct {
    long old_counts;
    double old_out;
} knob2float_data;

FUNCTION(_) {
    long delta_counts;
    double tmp_out;

    if ( min_out > max_out ) {
	min_out = max_out;
    }
    delta_counts = counts - data.old_counts;
    if ( enable ) {
	tmp_out = data.old_out + delta_counts * scale;
	if ( tmp_out > max_out ) {
	    data.old_out = max_out;
	} else if ( tmp_out < min_out ) {
	    data.old_out = min_out;
	} else {
	    data.old_out = tmp_out;
	}
    }
    out = data.old_out;
    data.old_counts += delta_counts;
}

static int __comp_get_data_size(void) { return sizeof(knob2float_data); }
