/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:multiswitch:This component toggles between a specified number of output bits.");
MODULE_INFO(linuxcnc, "pin:up:bit:0:in:Receives signal to toggle up:false:None");
MODULE_INFO(linuxcnc, "pin:down:bit:0:in:Receives signal to toggle down:false:None");
MODULE_INFO(linuxcnc, "param:top-position:u32:0:rw:Number of positions:None:None");
MODULE_INFO(linuxcnc, "param:position:s32:0:rw:Current state (may be set in the HAL):None:None");
MODULE_INFO(linuxcnc, "pin:bit-##:bit:(32, 'personality'):out:Output bits:false:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "author:ArcEye schooner30@tiscali.co.uk / Andy Pugh andy@bodgesoc.org");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    int _personality;
    hal_bit_t *up;
    hal_bit_t *down;
    hal_bit_t *bit[32];
    hal_u32_t top_position;
    hal_s32_t position;
    int old_up;

    int old_down;

};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg, long personality) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_personality = personality;
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    personality = inst->_personality;
    r = hal_pin_bit_newf(HAL_IN, &(inst->up), comp_id,
        "%s.up", prefix);
    if(r != 0) return r;
    *(inst->up) = false;
    r = hal_pin_bit_newf(HAL_IN, &(inst->down), comp_id,
        "%s.down", prefix);
    if(r != 0) return r;
    *(inst->down) = false;
    if((personality) > (32)) {
        rtapi_print_msg(RTAPI_MSG_ERR,"Pin bit-##: Requested size %d exceeds max size %d\n",(int)personality, (int)32);
        return -ENOSPC;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_bit_newf(HAL_OUT, &(inst->bit[j]), comp_id,
            "%s.bit-%02d", prefix, j);
        if(r != 0) return r;
    *(inst->bit[j]) = false;
    }
    r = hal_param_u32_newf(HAL_RW, &(inst->top_position), comp_id,
        "%s.top-position", prefix);
    if(r != 0) return r;
    r = hal_param_s32_newf(HAL_RW, &(inst->position), comp_id,
        "%s.position", prefix);
    if(r != 0) return r;
    inst->old_up = 0.0;
    inst->old_down = 0.0;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int get_count(void);
static int personality[64] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
RTAPI_MP_ARRAY_INT(personality, 64, "personality of each multiswitch");

            static int p_value(char* cname, char *name, int idx) {
                int ans = personality[idx%64];
                if (idx >= 64) {
            

                    if (name==NULL) {
                        rtapi_print_msg(RTAPI_MSG_ERR,"%s: instance %d assigned personality=%d(=%#0x)\n",
                                        cname, idx, ans, ans);
                    } else {
                        rtapi_print_msg(RTAPI_MSG_ERR,"%s: name %s assigned personality=%d(=%#0x)\n",
                                        cname, name, ans, ans);
                    }
                }
                return ans;
            }
            
int rtapi_app_main(void) {
    int r = 0;
    int i;
    int count = get_count();
    comp_id = hal_init("multiswitch");
    if(comp_id < 0) return comp_id;
    for(i=0; i<count; i++) {
        char buf[HAL_NAME_LEN + 1];
        rtapi_snprintf(buf, sizeof(buf), "multiswitch.%d", i);
        r = export(buf, i, p_value("multiswitch", buf, i) );
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef up
#define up (0+*__comp_inst->up)
#undef down
#define down (0+*__comp_inst->down)
#undef bit
#define bit(i) (*(__comp_inst->bit[i]))
#undef top_position
#define top_position (__comp_inst->top_position)
#undef position
#define position (__comp_inst->position)
#undef old_up
#define old_up (__comp_inst->old_up)
#undef old_down
#define old_down (__comp_inst->old_down)
#undef personality
#define personality (__comp_inst->_personality)


#line 46 "hal/components/multiswitch.comp"

#define MAX_COUNT 32
int cfg[MAX_COUNT];
RTAPI_MP_ARRAY_INT(cfg, MAX_COUNT, "array of function sizes");

FUNCTION(_) {
    int i;
    
    // debounce
    if (up && !old_up) { position++; }
    if (down && !old_down) { position--;}
    old_up = up;
    old_down = down;
    
    if (position < 0) position = top_position;
    if (position > top_position) position = 0;
    
    for (i = 0 ; i < personality; i++){
        bit(i) = (i == position);
    }

}

EXTRA_SETUP(){
    personality = cfg[extra_arg];
    top_position = personality - 1;
    return 0;
}

int get_count(void){
    int i;
    for (i=0; cfg[i] != 0 && i < MAX_COUNT; i++){}
    if (i == 0){
        cfg[0] = 4;
        i = 1;
    }
    return i;
}


static int __comp_get_data_size(void) { return 0; }
