/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:mux16:Select from one of sixteen input values");
MODULE_INFO(linuxcnc, "pin:use_graycode:bit:0:in:This signifies the input will use Gray code instead of binary.\nGray code is a good choice when using physical switches because\nfor each increment only one select input changes at a time.\n:None:None");
MODULE_INFO(linuxcnc, "pin:suppress_no_input:bit:0:in:This suppresses changing the output if all select lines are false.\nThis stops unwanted jumps in output between transitions of input.\nbut make in00 unavailable.\n:None:None");
MODULE_INFO(linuxcnc, "pin:debounce_time:float:0:in:sets debounce time in seconds.  eg. .10 = a tenth of a second\ninput must be stable this long before outputs changes. This\nhelps to ignore 'noisy' switches.\n:None:None");
MODULE_INFO(linuxcnc, "pin:sel#:bit:4:in:Together, these determine which \\fBin\\fIN\\fR value is copied to \\fBout\\fR.\n:None:None");
MODULE_INFO(linuxcnc, "pin:out_f:float:0:out::None:None");
MODULE_INFO(linuxcnc, "pin:out_s:s32:0:out:Follows the value of one of the \\fBin\\fIN\\fR values according to the four \\fBsel\\fR values\nand whether use-graycode is active.\nThe s32 value will be trunuated and limited to the max and min values of signed values. \n.RS\n.TP\n\\fBsel3=FALSE\\fR, \\fBsel2=FALSE\\fR, \\fBsel1=FALSE\\fR, \\fBsel0=FALSE\\fR\n\\fBout\\fR follows \\fBin0\\fR\n.TP\n\\fBsel3=FALSE\\fR, \\fBsel2=FALSE\\fR, \\fBsel1=FALSE\\fR, \\fBsel0=TRUE\\fR\n\\fBout\\fR follows \\fBin1\\fR\n.TP\netc.\n.RE\n:None:None");
MODULE_INFO(linuxcnc, "param:elapsed:float:0:r:Current value of the internal debounce timer\n for debugging.:None:None");
MODULE_INFO(linuxcnc, "param:selected:s32:0:r:Current value of the internal selection variable after conversion\n for debugging:None:None");
MODULE_INFO(linuxcnc, "pin:in##:float:16:in:array of selectable outputs:None:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Chris S Morley");
MODULE_INFO(linuxcnc, "see_also:mux2(9), mux4(9), mux8(9), mux_generic(9).");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *use_graycode;
    hal_bit_t *suppress_no_input;
    hal_float_t *debounce_time;
    hal_bit_t *sel[4];
    hal_float_t *out_f;
    hal_s32_t *out_s;
    hal_float_t *in[16];
    hal_float_t elapsed;
    hal_s32_t selected;
    double delaytime;

    int lastnum;

    int running;

};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_bit_newf(HAL_IN, &(inst->use_graycode), comp_id,
        "%s.use-graycode", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->suppress_no_input), comp_id,
        "%s.suppress-no-input", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->debounce_time), comp_id,
        "%s.debounce-time", prefix);
    if(r != 0) return r;
    for(j=0; j < (4); j++) {
        r = hal_pin_bit_newf(HAL_IN, &(inst->sel[j]), comp_id,
            "%s.sel%01d", prefix, j);
        if(r != 0) return r;
    }
    r = hal_pin_float_newf(HAL_OUT, &(inst->out_f), comp_id,
        "%s.out-f", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->out_s), comp_id,
        "%s.out-s", prefix);
    if(r != 0) return r;
    for(j=0; j < (16); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->in[j]), comp_id,
            "%s.in%02d", prefix, j);
        if(r != 0) return r;
    }
    r = hal_param_float_newf(HAL_RO, &(inst->elapsed), comp_id,
        "%s.elapsed", prefix);
    if(r != 0) return r;
    r = hal_param_s32_newf(HAL_RO, &(inst->selected), comp_id,
        "%s.selected", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of mux16");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of mux16");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("mux16");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "mux16.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef use_graycode
#define use_graycode (0+*__comp_inst->use_graycode)
#undef suppress_no_input
#define suppress_no_input (0+*__comp_inst->suppress_no_input)
#undef debounce_time
#define debounce_time (0+*__comp_inst->debounce_time)
#undef sel
#define sel(i) (0+*(__comp_inst->sel[i]))
#undef out_f
#define out_f (*__comp_inst->out_f)
#undef out_s
#define out_s (*__comp_inst->out_s)
#undef in
#define in(i) (0+*(__comp_inst->in[i]))
#undef elapsed
#define elapsed (__comp_inst->elapsed)
#undef selected
#define selected (__comp_inst->selected)
#undef delaytime
#define delaytime (__comp_inst->delaytime)
#undef lastnum
#define lastnum (__comp_inst->lastnum)
#undef running
#define running (__comp_inst->running)


#line 47 "hal/components/mux16.comp"
FUNCTION(_) {
    int i,num = 0;
    int internal[4];

    if(suppress_no_input) {
        if (sel(0) + sel(1) + sel(2) + sel(3) == 0) {
            return;
        }
    }
    if (use_graycode) {
        internal[0] = sel(3);
        internal[1] = sel(2);
        internal[2] = sel(1);
        internal[3] = sel(0);
        for(i = 1; i < 4; i++){
            internal[i] = internal[i] ^ internal[i - 1];
        }
        selected = num = internal[3]+(internal[2]*2) + (internal[1]*4) + (internal[0]*8);
    }else{
        selected = num = (sel(0))+(sel(1)*2) + (sel(2)*4) + (sel(3)*8);
    }
    if(debounce_time) {
        if (num != lastnum) {
            if (!running) {
                running = 1;
                delaytime = 0;
            }
            if (delaytime < debounce_time) {
                delaytime += fperiod;
                elapsed = delaytime;
                return;
            }else{
            running = 0;
            lastnum = num;
            out_s = out_f = in(num);
            return;
            }
        }
    }
    /* select the output */
    out_s = out_f = in(num);

}

static int __comp_get_data_size(void) { return 0; }
