/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:near:Determine whether two values are roughly equal.");
MODULE_INFO(linuxcnc, "pin:in1_:float:0:in::None:None");
MODULE_INFO(linuxcnc, "pin:in2_:float:0:in::None:None");
MODULE_INFO(linuxcnc, "param:scale:float:0:rw::1:None");
MODULE_INFO(linuxcnc, "param:difference:float:0:rw::0:None");
MODULE_INFO(linuxcnc, "pin:out:bit:0:out:\n\\fBout\\fR is true if \\fBin1\\fR and \\fBin2\\fR are within a factor of\n\\fBscale\\fR (i.e., for in1 positive, in1/scale <= in2 <= in1*scale), OR\nif their absolute difference is no greater than \\fBdifference\\fR (i.e.,\n|in1-in2| <= difference).  \\fBout\\fR is false otherwise.:None:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Chris Radek");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *in1_;
    hal_float_t *in2_;
    hal_bit_t *out;
    hal_float_t scale;
    hal_float_t difference;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_float_newf(HAL_IN, &(inst->in1_), comp_id,
        "%s.in1", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->in2_), comp_id,
        "%s.in2", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->scale), comp_id,
        "%s.scale", prefix);
    inst->scale = 1;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->difference), comp_id,
        "%s.difference", prefix);
    inst->difference = 0;
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of near");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of near");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("near");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "near.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in1_
#define in1_ (0+*__comp_inst->in1_)
#undef in2_
#define in2_ (0+*__comp_inst->in2_)
#undef out
#define out (*__comp_inst->out)
#undef scale
#define scale (__comp_inst->scale)
#undef difference
#define difference (__comp_inst->difference)


#line 15 "hal/components/near.comp"
#include "rtapi_math.h"
FUNCTION(_) {
	double in1 = in1_, in2 = in2_;
	if(in1 < 0) {
		in1 = -in1;
		in2 = -in2;
	}
	if((scale > 1 && in1/scale <= in2 && in2 <= in1*scale) || fabs(in1-in2) <= difference) {
		out = 1;
	}
	else {
		out = 0;
	}
}

static int __comp_get_data_size(void) { return 0; }
