/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:oneshot:one-shot pulse generator");
MODULE_INFO(linuxcnc, "descr:creates a variable-length output pulse when the input changes \nstate. This function needs to run in a thread which supports floating point\n(typically the servo thread). This means that the pulse length has to be a\nmultiple of that thread period, typically 1mS. \nFor a similar function that can run in the base thread, and which offers higher \nresolution, see \"edge\".");
MODULE_INFO(linuxcnc, "pin:in:bit:0:in:Trigger input:None:None");
MODULE_INFO(linuxcnc, "pin:reset:bit:0:in:Reset:None:None");
MODULE_INFO(linuxcnc, "pin:out:bit:0:out:Active high pulse:None:None");
MODULE_INFO(linuxcnc, "pin:out_not:bit:0:out:Active low pulse:None:None");
MODULE_INFO(linuxcnc, "pin:width:float:0:in:Pulse width in seconds:0:None");
MODULE_INFO(linuxcnc, "pin:time_left:float:0:out:Time left in current output pulse:None:None");
MODULE_INFO(linuxcnc, "param:retriggerable:bit:0:rw:Allow additional edges to extend pulse:TRUE:None");
MODULE_INFO(linuxcnc, "param:rising:bit:0:rw:Trigger on rising edge:TRUE:None");
MODULE_INFO(linuxcnc, "param:falling:bit:0:rw:Trigger on falling edge:FALSE:None");
MODULE_INFO(linuxcnc, "funct:_:1:Produce output pulses from input edges");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:John Kasunich");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *in;
    hal_bit_t *reset;
    hal_bit_t *out;
    hal_bit_t *out_not;
    hal_float_t *width;
    hal_float_t *time_left;
    hal_bit_t retriggerable;
    hal_bit_t rising;
    hal_bit_t falling;
    void *_data;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_data = (char*)inst + sizeof(struct __comp_state);
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->in), comp_id,
        "%s.in", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->reset), comp_id,
        "%s.reset", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->out_not), comp_id,
        "%s.out-not", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->width), comp_id,
        "%s.width", prefix);
    if(r != 0) return r;
    *(inst->width) = 0;
    r = hal_pin_float_newf(HAL_OUT, &(inst->time_left), comp_id,
        "%s.time-left", prefix);
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RW, &(inst->retriggerable), comp_id,
        "%s.retriggerable", prefix);
    inst->retriggerable = TRUE;
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RW, &(inst->rising), comp_id,
        "%s.rising", prefix);
    inst->rising = TRUE;
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RW, &(inst->falling), comp_id,
        "%s.falling", prefix);
    inst->falling = FALSE;
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of oneshot");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of oneshot");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("oneshot");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "oneshot.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*__comp_inst->in)
#undef reset
#define reset (0+*__comp_inst->reset)
#undef out
#define out (*__comp_inst->out)
#undef out_not
#define out_not (*__comp_inst->out_not)
#undef width
#define width (0+*__comp_inst->width)
#undef time_left
#define time_left (*__comp_inst->time_left)
#undef retriggerable
#define retriggerable (__comp_inst->retriggerable)
#undef rising
#define rising (__comp_inst->rising)
#undef falling
#define falling (__comp_inst->falling)
#undef data
#define data (*(internal*)(__comp_inst->_data))


#line 45 "hal/components/oneshot.comp"

typedef struct {
    double timer;
    char old_in;
} internal;

EXTRA_SETUP(){
    data.timer = 0.0;
    data.old_in = 0;
    return 0;
}

FUNCTION(_){ 
    int new, old, trigger;

    if (reset) {
        data.timer = 0.0;
        data.old_in = 0;
        out = 0;
        out_not = 1;
        return;
    }
    new = in;
    old = data.old_in;
    trigger = 0;
    /* detect edges */
    if ( new && (!old) && rising ) trigger = 1;
    if ( old && (!new) && falling ) trigger = 1;
    data.old_in = new;
    /* is a pulse already running? */
    if ( data.timer > 0.0 ) {
	if ( ! retriggerable ) {
	    /* ignore edges during pulse */
	    trigger = 0;
	}
	/* decrement timer */
	data.timer -= period * 0.000000001;
	if ( data.timer < 0.0 ) data.timer = 0.0;
    }
    if ( trigger ) {
	/* (re)start pulse */
	data.timer = width;
    }
    /* drive outputs */
    time_left = data.timer;
    if ( data.timer > 0.0 ) {
	out = 1;
	out_not = 0;
    } else {
	out = 0;
	out_not = 1;
    }
}


static int __comp_get_data_size(void) { return sizeof(internal); }
