/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:sim_home_switch:Home switch simulator");
MODULE_INFO(linuxcnc, "descr:\nAfter tripping home switch, travel in opposite direction is\nrequired (amount set by the hysteresis pin).\nA pin (index-enable) is provided for use when\n\\fB[JOINT_n]HOME_USE_INDEX\\fR is specified to reset\nthe I/O pin \\fBjoint.N.index-enable\\fR.\n");
MODULE_INFO(linuxcnc, "pin:cur_pos:float:0:in:Current position (typically: joint.n.motor-pos-fb):None:None");
MODULE_INFO(linuxcnc, "pin:home_pos:float:0:in:Home switch position:1:None");
MODULE_INFO(linuxcnc, "pin:hysteresis:float:0:in:Travel required to backoff (hysteresis):0.1:None");
MODULE_INFO(linuxcnc, "pin:home_sw:bit:0:out:Home switch activated:None:None");
MODULE_INFO(linuxcnc, "pin:index_enable:bit:0:io:typ: connect to joint.N.index-enable:None:None");
MODULE_INFO(linuxcnc, "pin:index_delay_ms:float:0:in:delay in msec to reset index-enable:10:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Dewey Garrett");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *cur_pos;
    hal_float_t *home_pos;
    hal_float_t *hysteresis;
    hal_bit_t *home_sw;
    hal_bit_t *index_enable;
    hal_float_t *index_delay_ms;
    int old_index_enable;

    double index_timer_ms;

};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_float_newf(HAL_IN, &(inst->cur_pos), comp_id,
        "%s.cur-pos", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->home_pos), comp_id,
        "%s.home-pos", prefix);
    if(r != 0) return r;
    *(inst->home_pos) = 1;
    r = hal_pin_float_newf(HAL_IN, &(inst->hysteresis), comp_id,
        "%s.hysteresis", prefix);
    if(r != 0) return r;
    *(inst->hysteresis) = 0.1;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->home_sw), comp_id,
        "%s.home-sw", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IO, &(inst->index_enable), comp_id,
        "%s.index-enable", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->index_delay_ms), comp_id,
        "%s.index-delay-ms", prefix);
    if(r != 0) return r;
    *(inst->index_delay_ms) = 10;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of sim_home_switch");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of sim_home_switch");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("sim_home_switch");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "sim-home-switch.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef cur_pos
#define cur_pos (0+*__comp_inst->cur_pos)
#undef home_pos
#define home_pos (0+*__comp_inst->home_pos)
#undef hysteresis
#define hysteresis (0+*__comp_inst->hysteresis)
#undef home_sw
#define home_sw (*__comp_inst->home_sw)
#undef index_enable
#define index_enable (*__comp_inst->index_enable)
#undef index_delay_ms
#define index_delay_ms (0+*__comp_inst->index_delay_ms)
#undef old_index_enable
#define old_index_enable (__comp_inst->old_index_enable)
#undef index_timer_ms
#define index_timer_ms (__comp_inst->index_timer_ms)


#line 26 "hal/components/sim_home_switch.comp"

FUNCTION(_) {
    // could be simplified but this style is meant to be easy-to-read
    if (home_pos >= 0) {
        // home switch is on positive side
        if (cur_pos >= home_pos) {
            home_sw = 1;
        } else {
            if (cur_pos <= (home_pos - hysteresis) ) {
                home_sw = 0;
            } else {
                if (home_sw) {
                    home_sw = 1;
                } else {
                    home_sw = 0;
                }
            }
        }
    } else {
        // negative home switch location
        if (cur_pos <= home_pos) {
            home_sw = 1;
        } else {
            if (cur_pos >= (home_pos + hysteresis) ) {
                home_sw = 0;
            } else {
                if (home_sw) {
                    home_sw = 1;
                } else {
                    home_sw = 0;
                }
            }
        }
    }

    // provision to reset I/O pin index-enable
    if (index_timer_ms > 0) {
       index_timer_ms -= period * 1e-6; // period is in nS
       if (index_timer_ms <= 0) {
           index_timer_ms = 0;
           index_enable = 0;
           return;
       }
    }
    if (index_enable && !old_index_enable) {
        index_timer_ms = index_delay_ms;
    }
    old_index_enable = index_enable;
    return;
}

static int __comp_get_data_size(void) { return 0; }
