/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:sum2:Sum of two inputs (each with a gain) and an offset");
MODULE_INFO(linuxcnc, "see_also:scaled_s32_sums(9), weighted_sum(9)");
MODULE_INFO(linuxcnc, "pin:in0:float:0:in::None:None");
MODULE_INFO(linuxcnc, "pin:in1:float:0:in::None:None");
MODULE_INFO(linuxcnc, "param:gain0:float:0:rw::1.0:None");
MODULE_INFO(linuxcnc, "param:gain1:float:0:rw::1.0:None");
MODULE_INFO(linuxcnc, "param:offset:float:0:rw::None:None");
MODULE_INFO(linuxcnc, "pin:out:float:0:out:out = in0 * gain0 + in1 * gain1 + offset:None:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Jeff Epler");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *in0;
    hal_float_t *in1;
    hal_float_t *out;
    hal_float_t gain0;
    hal_float_t gain1;
    hal_float_t offset;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_float_newf(HAL_IN, &(inst->in0), comp_id,
        "%s.in0", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->in1), comp_id,
        "%s.in1", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->gain0), comp_id,
        "%s.gain0", prefix);
    inst->gain0 = 1.0;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->gain1), comp_id,
        "%s.gain1", prefix);
    inst->gain1 = 1.0;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->offset), comp_id,
        "%s.offset", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of sum2");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of sum2");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("sum2");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "sum2.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in0
#define in0 (0+*__comp_inst->in0)
#undef in1
#define in1 (0+*__comp_inst->in1)
#undef out
#define out (*__comp_inst->out)
#undef gain0
#define gain0 (__comp_inst->gain0)
#undef gain1
#define gain1 (__comp_inst->gain1)
#undef offset
#define offset (__comp_inst->offset)


#line 13 "hal/components/sum2.comp"
FUNCTION(_) {
    out = in0 * gain0 + in1 * gain1 + offset;
}

static int __comp_get_data_size(void) { return 0; }
