/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:toggle:'push-on, push-off' from momentary pushbuttons");
MODULE_INFO(linuxcnc, "descr:\n     ┐     ┏──┐        ┏──┐  \n.br\nin : └─────┛  └────────┛  └──\n.br\n     ┐     ┌───────────┐     \n.br\nout: └─────┘           └─────\n");
MODULE_INFO(linuxcnc, "pin:in:bit:0:in:button input:None:None");
MODULE_INFO(linuxcnc, "pin:out:bit:0:io:on/off output:None:None");
MODULE_INFO(linuxcnc, "param:debounce:u32:0:rw:debounce delay in periods:2:None");
MODULE_INFO(linuxcnc, "funct:_:0:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:John Kasunich");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *in;
    hal_bit_t *out;
    hal_u32_t debounce;
    void *_data;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_data = (char*)inst + sizeof(struct __comp_state);
    r = hal_pin_bit_newf(HAL_IN, &(inst->in), comp_id,
        "%s.in", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IO, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_param_u32_newf(HAL_RW, &(inst->debounce), comp_id,
        "%s.debounce", prefix);
    inst->debounce = 2;
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 0, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of toggle");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of toggle");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("toggle");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "toggle.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*__comp_inst->in)
#undef out
#define out (*__comp_inst->out)
#undef debounce
#define debounce (__comp_inst->debounce)
#undef data
#define data (*(toggle_data*)(__comp_inst->_data))


#line 23 "hal/components/toggle.comp"

typedef struct {
    int debounce_cntr;
    int debounced;
} toggle_data;

FUNCTION(_) {

    if (( debounce < 1 ) || ( debounce > 10000 )) {
	/* set a sane value, we don't want 2 million second delays */
	debounce = 2;
    }
    if ( in ) {
	/* pressed */
	data.debounce_cntr++;
	if ( data.debounce_cntr >= debounce ) {
	    data.debounce_cntr = debounce;
	    if ( data.debounced == 0 ) {
		/* toggle output */
		out = !out;
	    }
	    data.debounced = 1;
	}
    } else {
	/* not pressed */
	data.debounce_cntr--;
	if ( data.debounce_cntr <= 0 ) {
	    data.debounce_cntr = 0;
	    data.debounced = 0;
	}
    }
}

static int __comp_get_data_size(void) { return sizeof(toggle_data); }
