/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:userkins:Template for user-built kinematics");
MODULE_INFO(linuxcnc, "descr:\n.if \\n[.g] .mso www.tmac\n\nThe userkins.comp file is a template for creating\nkinematics that can be user-built using halcompile.\n\nThe unmodified userkins component can be used\nas a kinematics file for a machine with identity\nkinematics for an xyz machine employing 3 joints\n(motors).\n\n\\fBUSAGE:\\fR\n\n  1) Copy the userkins.comp file to a user-owned\n     directory (\\fBmydir\\fR).\n\n     Note: The userkins.comp file can be downloaded from:\n.URL https://github.com/LinuxCNC/linuxcnc/raw/2.8/src/hal/components/userkins.comp\n     where '2.8' is the branch name (use 'master' for\n     the master branch)\n\n     For a RIP (run-in-place) build, the file is located in\n     the git tree as:\n       src/hal/components/userkins.comp\n\n  2) Edit the functions kinematicsForward() and\n     kinematicsInverse() as required\n  3) If required, add hal pins following examples in\n     the template code\n  4) Build and install the component using halcompile:\n     $ cd \\fBmydir\\fR\n     $ [sudo] halcompile --install userkins.comp\n     # Note:\n     #      sudo is required when using a deb install\n     #      sudo is \\fBnot\\fR required for run-in-place builds\n     # $ man halcompile for more info\n  5) Specify userkins in an ini file as:\n     \\fB[KINS]\\fR\n     \\fBKINEMATICS=userkins\\fR\n     \\fBJOINTS=3\\fR\n     # the number of JOINTS must agree with the\n     # number of joints used in your modified userkins.comp\n  6) Note: the manpage for userkins is not updated by\n     halcompile --install\n  7) To use a different component name, rename the file\n     (example mykins.comp) and change all instances of\n     'userkins' to 'mykins'\n\n\\fBNOTES:\\fR\n  1  The \\fBfpin\\fR pin is included to satisfy the requirements of\n     the halcompile utility but it is not accessible to kinematics\n     functions.\n\n  2  Hal pins and parameters needed in kinematics functions\n     (kinematicsForward(), kinematicsInverse()) must\n     be setup in a function (\\fBuserkins_setup()\\fR) invoked\n     by the initial motion module call to kinematicsType().\n");
MODULE_INFO(linuxcnc, "pin:fpin:s32:0:out:pin to demonstrate use of a conventional (non-kinematics) function fdemo:0:None");
MODULE_INFO(linuxcnc, "funct:fdemo:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Dewey Garrett");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_s32_t *fpin;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void fdemo(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_s32_newf(HAL_OUT, &(inst->fpin), comp_id,
        "%s.fpin", prefix);
    if(r != 0) return r;
    *(inst->fpin) = 0;
    rtapi_snprintf(buf, sizeof(buf), "%s.fdemo", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))fdemo, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of userkins");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of userkins");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("userkins");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "userkins.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef fpin
#define fpin (*__comp_inst->fpin)


#line 69 "hal/components/userkins.comp"

#include "rtapi_math.h"
#include "kinematics.h"

static struct haldata {
  // Example pin pointers
  hal_u32_t *in;
  hal_u32_t *out;
  // Example parameters
  hal_float_t param_rw;
  hal_float_t param_ro;
} *haldata;
// hal pin/param types:
// hal_bit_t   bit
// hal_u32_t   unsigned 32bit integer
// hal_s32_t   signed 32bit integer
// hal_float_t float (double precision)

FUNCTION(fdemo) {
   // This function can be added to a thread (addf) for
   // purposes not related to the kinematics functions.
   if (fpin == 0) {
       rtapi_print("fdemo function added to thread\n");
   }
   fpin++;
}

static int userkins_setup(void) {
#define HAL_PREFIX "userkins"
    int res=0;

    // inherit comp_id from rtapi_main()
    if (comp_id < 0) goto error;
    // set unready to allow creation of pins
    if (hal_set_unready(comp_id)) goto error;

    haldata = hal_malloc(sizeof(struct haldata));
    if (!haldata) goto error;

    // hal pin examples:
    res += hal_pin_u32_newf(HAL_IN ,&(haldata->in) ,comp_id,"%s.in" ,HAL_PREFIX);
    res += hal_pin_u32_newf(HAL_OUT,&(haldata->out),comp_id,"%s.out",HAL_PREFIX);

    // hal parameter examples:
    res += hal_param_float_newf(HAL_RW, &haldata->param_rw,comp_id,"%s.param-rw",HAL_PREFIX);
    res += hal_param_float_newf(HAL_RO, &haldata->param_ro,comp_id,"%s.param-ro",HAL_PREFIX);

    if (res) goto error;
    hal_ready(comp_id);
    rtapi_print("*** %s setup ok\n",__FILE__);
    return 0;
error:
    rtapi_print("\n!!! %s setup failed res=%d\n\n",__FILE__,res);
    return -1;
#undef HAL_PREFIX
}

KINS_NOT_SWITCHABLE
// see millturn.comp for example of switchable kinematics

EXPORT_SYMBOL(kinematicsType);
EXPORT_SYMBOL(kinematicsInverse);
EXPORT_SYMBOL(kinematicsForward);

KINEMATICS_TYPE kinematicsType()
{
static bool is_setup=0;
    if (!is_setup) userkins_setup();
    return KINEMATICS_IDENTITY; // set as required
           // Note: If kinematics are identity, using KINEMATICS_BOTH
           //       may be used in order to allow a gui to display
           //       joint values in preview prior to homing
} // kinematicsType()

static bool is_ready=0;
int kinematicsForward(const double *j,
                      EmcPose * pos,
                      const KINEMATICS_FORWARD_FLAGS * fflags,
                      KINEMATICS_INVERSE_FLAGS * iflags)
{
    static bool gave_msg;
    // [KINS]JOINTS=3
    pos->tran.x = j[0]; // X coordinate
    pos->tran.y = j[1]; // Y coordinate
    pos->tran.z = j[2]; // Z coordinate
    // unused coordinates:
    pos->a = 0;
    pos->b = 0;
    pos->c = 0;
    pos->u = 0;
    pos->v = 0;
    pos->w = 0;

    if (*haldata->in && !is_ready && !gave_msg) {
       rtapi_print_msg(RTAPI_MSG_ERR,
                       "%s The 'in' pin not echoed until Inverse called\n",
                      __FILE__);
       gave_msg=1;
    }
    return 0;
} // kinematicsForward()

int kinematicsInverse(const EmcPose * pos,
                      double *j,
                      const KINEMATICS_INVERSE_FLAGS * iflags,
                      KINEMATICS_FORWARD_FLAGS * fflags)
{
    is_ready = 1; // Inverse is not called until homed for KINEMATICS_BOTH

    // Update the kinematic joints specified by the
    // [KINS]JOINTS setting (3 required for this template).
    // Maximum number of joints is defined in include file:
    //         emcmotcfg:EMCMOT_MAX_JOINTS (typ 16)
    // Some joints may be claimed as 'extrajoints' and
    // do not participate in kinematics calculations --
    // $ man motion for more info
    j[0] = pos->tran.x; // joint 0
    j[1] = pos->tran.y; // joint 1
    j[2] = pos->tran.z; // joint 2

    //example hal pin update (homing reqd before kinematicsInverse)
    *haldata->out = *haldata->in; //dereference
    //read from param example: *haldata->out = haldata->param_rw;

    return 0;
} // kinematicsInverse()

static int __comp_get_data_size(void) { return 0; }
