/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:10:53 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#include <hostmot2-serial.h>
#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:mesa_7i65:Support for the Mesa 7i65 Octuple Servo Card");
MODULE_INFO(linuxcnc, "descr:The component takes parameters in the form of a comma-separated\nlist of bspi (buffered SPI) instance names, for example:\n\n\\fB loadrt mesa_7i65 bspi_chans=hm2_5i23.0.bspi.0, hm2_5i23.0.bspi.1\\fR\n\nThe BSPI instances are printed to the dmesg buffer during the Hostmot2 setup\nsequence, one for each bspi instance included in the bitfile loaded to each\ninstalled card during the Hostmot2 setup sequence. Type \"dmesg\" at the terminal\nprompt to view the output.");
MODULE_INFO(linuxcnc, "pin:analogue.#.out:float:8:in:Analogue output values. The value will be\nlimited to a  -1.0 to +1.0 range:None:None");
MODULE_INFO(linuxcnc, "pin:analogue.#.in:float:8:out:Analogue outputs read by the 7i65 (in Volts):None:None");
MODULE_INFO(linuxcnc, "pin:digital.#.in:bit:4:out:Miscellaneous Digital Inputs:None:None");
MODULE_INFO(linuxcnc, "pin:enable.#.out:bit:8:in:Amplifier-enable control pins:None:None");
MODULE_INFO(linuxcnc, "pin:watchdog.has-bit:bit:0:out:Indicates the status of the 7i65 Watchdog (which\nis separate from the FPGA card watchdog:None:None");
MODULE_INFO(linuxcnc, "param:scale-#:float:8:rw:Analogue output scale factor. For example if\nthe scale is 7 then an input of 1.0 will give 7V on the output terminals:10:None");
MODULE_INFO(linuxcnc, "param:is-bipolar-#:bit:8:rw:Set this value to TRUE for a plus/minus\n\"scale\" output. Set to 0 for a 0-\"scale\" output:1:None");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Andy Pugh / Cliff Blackburn");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *analogue_out[8];
    hal_float_t *analogue_in[8];
    hal_bit_t *digital_in[4];
    hal_bit_t *enable_out[8];
    hal_bit_t *watchdog_has_bit;
    hal_float_t scale[8];
    hal_bit_t is_bipolar[8];
    unsigned firstrun;

    unsigned *AD5754_1A;

    unsigned *AD5754_1B;

    unsigned *AD5754_1C;

    unsigned *AD5754_1D;

    unsigned *AD5754_2A;

    unsigned *AD5754_2B;

    unsigned *AD5754_2C;

    unsigned *AD5754_2D;

    unsigned *CPLD_write;

    unsigned *CPLD_read;

    unsigned *AD7329_write[8];

    unsigned *AD7329_read[8];

};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    int r = 0;
    int j = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    for(j=0; j < (8); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->analogue_out[j]), comp_id,
            "%s.analogue.%01d.out", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (8); j++) {
        r = hal_pin_float_newf(HAL_OUT, &(inst->analogue_in[j]), comp_id,
            "%s.analogue.%01d.in", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (4); j++) {
        r = hal_pin_bit_newf(HAL_OUT, &(inst->digital_in[j]), comp_id,
            "%s.digital.%01d.in", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (8); j++) {
        r = hal_pin_bit_newf(HAL_IN, &(inst->enable_out[j]), comp_id,
            "%s.enable.%01d.out", prefix, j);
        if(r != 0) return r;
    }
    r = hal_pin_bit_newf(HAL_OUT, &(inst->watchdog_has_bit), comp_id,
        "%s.watchdog.has-bit", prefix);
    if(r != 0) return r;
    for(j=0; j < (8); j++) {
        r = hal_param_float_newf(HAL_RW, &(inst->scale[j]), comp_id,
            "%s.scale-%01d", prefix, j);
        if(r != 0) return r;
    inst->scale[j] = 10;
    }
    for(j=0; j < (8); j++) {
        r = hal_param_bit_newf(HAL_RW, &(inst->is_bipolar[j]), comp_id,
            "%s.is-bipolar-%01d", prefix, j);
        if(r != 0) return r;
    inst->is_bipolar[j] = 1;
    }
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int get_count(void);
int rtapi_app_main(void) {
    int r = 0;
    int i;
    int count = get_count();
    comp_id = hal_init("mesa_7i65");
    if(comp_id < 0) return comp_id;
    for(i=0; i<count; i++) {
        char buf[HAL_NAME_LEN + 1];
        rtapi_snprintf(buf, sizeof(buf), "mesa-7i65.%d", i);
        r = export(buf, i);
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef analogue_out
#define analogue_out(i) (0+*(__comp_inst->analogue_out[i]))
#undef analogue_in
#define analogue_in(i) (*(__comp_inst->analogue_in[i]))
#undef digital_in
#define digital_in(i) (*(__comp_inst->digital_in[i]))
#undef enable_out
#define enable_out(i) (0+*(__comp_inst->enable_out[i]))
#undef watchdog_has_bit
#define watchdog_has_bit (*__comp_inst->watchdog_has_bit)
#undef scale
#define scale(i) (__comp_inst->scale[i])
#undef is_bipolar
#define is_bipolar(i) (__comp_inst->is_bipolar[i])
#undef firstrun
#define firstrun (__comp_inst->firstrun)
#undef AD5754_1A
#define AD5754_1A (__comp_inst->AD5754_1A)
#undef AD5754_1B
#define AD5754_1B (__comp_inst->AD5754_1B)
#undef AD5754_1C
#define AD5754_1C (__comp_inst->AD5754_1C)
#undef AD5754_1D
#define AD5754_1D (__comp_inst->AD5754_1D)
#undef AD5754_2A
#define AD5754_2A (__comp_inst->AD5754_2A)
#undef AD5754_2B
#define AD5754_2B (__comp_inst->AD5754_2B)
#undef AD5754_2C
#define AD5754_2C (__comp_inst->AD5754_2C)
#undef AD5754_2D
#define AD5754_2D (__comp_inst->AD5754_2D)
#undef CPLD_write
#define CPLD_write (__comp_inst->CPLD_write)
#undef CPLD_read
#define CPLD_read (__comp_inst->CPLD_read)
#undef AD7329_write
#define AD7329_write (__comp_inst->AD7329_write)
#undef AD7329_read
#define AD7329_read (__comp_inst->AD7329_read)


#line 48 "hal/drivers/mesa_7i65.comp"

// to parse the modparam
char *bspi_chans[16] = {0,};
RTAPI_MP_ARRAY_STRING(bspi_chans, 16, "BSPI Channel names");

static int read(void *subdata) {
    struct __comp_state *__comp_inst = subdata;
    int i;
    double aout[8];

    // Write Misc IO & Reset Watchdog
    *CPLD_write = 0xA00 // "write" command
               | (enable_out(7) != 0) << 7 | (enable_out(6) != 0) << 6
               | (enable_out(5) != 0) << 5 | (enable_out(4) != 0) << 4
               | (enable_out(3) != 0) << 3 | (enable_out(2) != 0) << 2
               | (enable_out(1) != 0) << 1 | (enable_out(0) != 0);

    // Read Analog to Digital
    *AD7329_write[0] = 0x00000000;
    *AD7329_write[1] = 0x00000000;
    *AD7329_write[2] = 0x00000000;
    *AD7329_write[3] = 0x00000000;
    *AD7329_write[4] = 0x00000000;
    *AD7329_write[5] = 0x00000000;
    *AD7329_write[6] = 0x00000000;
    *AD7329_write[7] = 0x00009C18; // Reset Sequencer to 0.. jic

    // Limit DAC Outputs
    for (i = 0 ; i < 8 ; i++) {
        if (scale(i) > 10)
            scale(i) = 10;
        if (scale(i) < -10)
            scale(i) = -10;

        aout[i] = analogue_out(i);
        if (aout[i] > 1)
            aout[i] = 1;
        if (is_bipolar(i)) {
            if (aout[i] < -1)
                aout[i] = -1;
        }
        else {
            if (aout[i] < 0)
                aout[i] = 0;
        }
    }

    *AD5754_1A = 0x00000000 |  // address
                     (0x0000FFFF &  // mask
                     (unsigned)((int16_t)(aout[0] * scale(0) * 3276.799)));

    *AD5754_1B = 0x00010000 |  // address
                     (0x0000FFFF &  // mask
                     (unsigned)((int16_t)(aout[1] * scale(1) * 3276.799)));

    *AD5754_1C = 0x00020000 |  // address
                     (0x0000FFFF &  // mask
                     (unsigned)((int16_t)(aout[2] * scale(2) * 3276.799)));

    *AD5754_1D = 0x00030000 |  // address
                     (0x0000FFFF &  // mask
                     (unsigned)((int16_t)(aout[3] * scale(3) * 3276.799)));

    *AD5754_2A = 0x00000000 |  // address
                     (0x0000FFFF &  // mask
                     (unsigned)((int16_t)(aout[4] * scale(4) * 3276.799)));

    *AD5754_2B = 0x00010000 |  // address
                     (0x0000FFFF &  // mask
                     (unsigned)((int16_t)(aout[5] * scale(5) * 3276.799)));

    *AD5754_2C = 0x00020000 |  // address
                     (0x0000FFFF &  // mask
                     (unsigned)((int16_t)(aout[6] * scale(6) * 3276.799)));

    *AD5754_2D = 0x00030000 |  // address
                     (0x0000FFFF &  // mask
                     (unsigned)((int16_t)(aout[7] * scale(7) * 3276.799)));

    // Setup DAC, watchdog will have reset it if done in setup
    if(firstrun) {
       // Setup DAC
            // DAC: write - range select - all chans - +/-10V
        *AD5754_1A = 0x000C0004;
        *AD5754_2A = 0x000C0004;
            // DAC: power up all channels
        *AD5754_1B = 0x0010000F;
        *AD5754_2B = 0x0010000F;

        // NOP, Reads
        *AD5754_1C = 0x00800000;
        *AD5754_2C = 0x00800000;
        *AD5754_1D = 0x00800000;
        *AD5754_2D = 0x00800000;

        firstrun = false;
    }

    // Read Misc IO and Watchdog from CPLD
    digital_in(0) = (*CPLD_read & 0x1) ? 1:0;
    digital_in(1) = (*CPLD_read & 0x2) ? 1:0;
    digital_in(2) = (*CPLD_read & 0x4) ? 1:0;
    digital_in(3) = (*CPLD_read & 0x8) ? 1:0;
    watchdog_has_bit = (*CPLD_read & 0x100) ? 1:0;

    // Read ADC's into Pins
    for(i=0; i < 8; i++) {
        analogue_in(i) = (double)((int16_t)((*AD7329_read[i] & 0x1FFF) << 3)) / 3276.8;
    }
    return 0;
}

EXTRA_SETUP(){
    int i, r;
    char *name = bspi_chans[extra_arg]; // This is the string which identifies board and instance

    firstrun = true;
    // Set up channel descriptors
    //hm2_bspi_setup_chan(name, chan, cs, bits, mhz, delay(ns), cpol, cpha, /clear, /echo, samplelate)
    // CS0 loopback Echo, CS0, ~ 4 MHz, CPOL, 32 bits
    r = hm2_bspi_setup_chan(name, 0, 0, 32, 4, 0, 1, 0, 0, 0, 0);
    // CS1 AD5754 No echo, CS1, 25 MHz, CPOL, 24 bits
    r += hm2_bspi_setup_chan(name, 1, 1, 24, 25, 0, 1, 0, 0, 1, 0);
    // CS2 AD5754 No echo, CS2, 25 MHz, CPOL, 24 bits
    r += hm2_bspi_setup_chan(name, 2, 2, 24, 25, 0, 1, 0, 0, 1, 0);
    // CS3 AD7329 Echo, CS3, ~6 MHz, CPOL, 16 bits
    r += hm2_bspi_setup_chan(name, 3, 3, 16, 6, 0, 1, 0, 0, 0, 0);
    // CS4 CPLD Echo, CS4, ~6 MHz, CPOL, 12 bits
    r += hm2_bspi_setup_chan(name, 4, 4, 12, 6, 0, 1, 0, 0, 0, 0);
    // CS5 Not Used No echo, CS5, 25 MHz, 2 bits
    r += hm2_bspi_setup_chan(name, 5, 5, 2, 25, 0, 1, 0, 0, 1, 0);
    // CS6 Not Used No echo, CS5, 25 MHz, 2 bits
    r += hm2_bspi_setup_chan(name, 6, 6, 2, 25, 0, 1, 0, 0, 1, 0);
    // CS7 EEPROM Echo, CS7, ~4 MHz, CPOL,CPHA, 8 bits
    r += hm2_bspi_setup_chan(name, 7, 7, 8, 4, 0, 1, 1, 0, 0, 0);
    // CS7 EEPROM No Echo, CS7, ~4 MHz, CPOL,CPHA, 8 bits
    r += hm2_bspi_setup_chan(name, 8, 7, 8, 4, 0, 1, 1, 0, 1, 0);
    // CS7 EEPROM No Echo, DontClearFrame, CS7, ~4 MHz,CPOL,CPHA, 8 bits
    r += hm2_bspi_setup_chan(name, 9, 7, 8, 4, 0, 1, 1, 1, 1, 0);

    if (r < 0) {
        rtapi_print_msg(RTAPI_MSG_ERR,
                      "There have been %i errors during channel setup, "
                      "quitting\n", -r);
        return -EINVAL;
    }

    // Setup ADC
        // ADC, chans 0-3 +/-10V
    r += hm2_bspi_write_chan(name, 3, 0x0000A000);
        // ADC, chans 4-7 +/-10V
    r += hm2_bspi_write_chan(name, 3, 0x0000C000);
        // ADC, Sequencer mode 2, Internal Ref, 8x Single Ended
    r += hm2_bspi_write_chan(name, 3, 0x00009C18);

    if (r < 0) {
        rtapi_print_msg(RTAPI_MSG_ERR,
                      "There have been %i errors during ADC setup, "
                      "quitting\n", -r);
        return -EINVAL;
    }

    // Clear BSPI Rx & Tx FIFOs.
    // This discards the received data from the ADC setup writes above,
    // and any other old stale data.
    r = hm2_bspi_clear_fifo(name);
    if (r < 0) {
        rtapi_print_msg(RTAPI_MSG_ERR, "failed to clear BSPI fifos on %s\n", name);
    }

    // Add BSPI Frames
    // digital inputs and outputs
    r += hm2_tram_add_bspi_frame(name, 4, &CPLD_write,
                            &CPLD_read);

    // analog inputs
    for(i = 0; i < 8; i++) {
        r += hm2_tram_add_bspi_frame(name, 3, &AD7329_write[i],
                                &AD7329_read[i]);
    }

    // analog outputs
    r += hm2_tram_add_bspi_frame(name, 1, &AD5754_1A,0);
    r += hm2_tram_add_bspi_frame(name, 1, &AD5754_1B,0);
    r += hm2_tram_add_bspi_frame(name, 1, &AD5754_1C,0);
    r += hm2_tram_add_bspi_frame(name, 1, &AD5754_1D,0);
    r += hm2_tram_add_bspi_frame(name, 2, &AD5754_2A,0);
    r += hm2_tram_add_bspi_frame(name, 2, &AD5754_2B,0);
    r += hm2_tram_add_bspi_frame(name, 2, &AD5754_2C,0);
    r += hm2_tram_add_bspi_frame(name, 2, &AD5754_2D,0);

    // This is required, or nothing happens.
    r += hm2_allocate_bspi_tram(name);

    // Tell the bspi driver which function to call
    r += hm2_bspi_set_read_function(name, &read, __comp_inst);

    // no separate write function in this example, but it would be:
    // r += hm2_bspi_set_write_function(name, &write, __comp_inst);

    if (r < 0) {
        rtapi_print_msg(RTAPI_MSG_ERR,
                      "There have been %i errors during TRAM allocation setup, "
                      "quitting\n", -r);
        return -EINVAL;
    }
    return 0;
}

int get_count(void){
    int i;
    for (i= 0; bspi_chans[i] != NULL && i < 16 ; i++){}
    return i;
}

static int __comp_get_data_size(void) { return 0; }
